~ [ source navigation ] ~ [ diff markup ] ~ [ identifier search ] ~

TOMOYO Linux Cross Reference
Linux/scripts/link-vmlinux.sh

Version: ~ [ linux-6.11.5 ] ~ [ linux-6.10.14 ] ~ [ linux-6.9.12 ] ~ [ linux-6.8.12 ] ~ [ linux-6.7.12 ] ~ [ linux-6.6.58 ] ~ [ linux-6.5.13 ] ~ [ linux-6.4.16 ] ~ [ linux-6.3.13 ] ~ [ linux-6.2.16 ] ~ [ linux-6.1.114 ] ~ [ linux-6.0.19 ] ~ [ linux-5.19.17 ] ~ [ linux-5.18.19 ] ~ [ linux-5.17.15 ] ~ [ linux-5.16.20 ] ~ [ linux-5.15.169 ] ~ [ linux-5.14.21 ] ~ [ linux-5.13.19 ] ~ [ linux-5.12.19 ] ~ [ linux-5.11.22 ] ~ [ linux-5.10.228 ] ~ [ linux-5.9.16 ] ~ [ linux-5.8.18 ] ~ [ linux-5.7.19 ] ~ [ linux-5.6.19 ] ~ [ linux-5.5.19 ] ~ [ linux-5.4.284 ] ~ [ linux-5.3.18 ] ~ [ linux-5.2.21 ] ~ [ linux-5.1.21 ] ~ [ linux-5.0.21 ] ~ [ linux-4.20.17 ] ~ [ linux-4.19.322 ] ~ [ linux-4.18.20 ] ~ [ linux-4.17.19 ] ~ [ linux-4.16.18 ] ~ [ linux-4.15.18 ] ~ [ linux-4.14.336 ] ~ [ linux-4.13.16 ] ~ [ linux-4.12.14 ] ~ [ linux-4.11.12 ] ~ [ linux-4.10.17 ] ~ [ linux-4.9.337 ] ~ [ linux-4.4.302 ] ~ [ linux-3.10.108 ] ~ [ linux-2.6.32.71 ] ~ [ linux-2.6.0 ] ~ [ linux-2.4.37.11 ] ~ [ unix-v6-master ] ~ [ ccs-tools-1.8.9 ] ~ [ policy-sample ] ~
Architecture: ~ [ i386 ] ~ [ alpha ] ~ [ m68k ] ~ [ mips ] ~ [ ppc ] ~ [ sparc ] ~ [ sparc64 ] ~

Diff markup

Differences between /scripts/link-vmlinux.sh (Version linux-6.11.5) and /scripts/link-vmlinux.sh (Version linux-2.6.0)


  1 #!/bin/sh                                         
  2 # SPDX-License-Identifier: GPL-2.0                
  3 #                                                 
  4 # link vmlinux                                    
  5 #                                                 
  6 # vmlinux is linked from the objects in vmlinu    
  7 # vmlinux.a contains objects that are linked u    
  8 # $(KBUILD_VMLINUX_LIBS) are archives which ar    
  9 # (not within --whole-archive), and do not req    
 10 #                                                 
 11 # vmlinux                                         
 12 #   ^                                             
 13 #   |                                             
 14 #   +--< vmlinux.a                                
 15 #   |                                             
 16 #   +--< $(KBUILD_VMLINUX_LIBS)                   
 17 #   |    +--< lib/lib.a + more                    
 18 #   |                                             
 19 #   +-< ${kallsymso} (see description in KALLS    
 20 #                                                 
 21 # vmlinux version (uname -v) cannot be updated    
 22 # descending-into-subdirs phase since we do no    
 23 # update vmlinux.                                 
 24 # Therefore this step is delayed until just be    
 25 #                                                 
 26 # System.map is generated to document addresse    
 27                                                   
 28 # Error out on error                              
 29 set -e                                            
 30                                                   
 31 LD="$1"                                           
 32 KBUILD_LDFLAGS="$2"                               
 33 LDFLAGS_vmlinux="$3"                              
 34                                                   
 35 is_enabled() {                                    
 36         grep -q "^$1=y" include/config/auto.co    
 37 }                                                 
 38                                                   
 39 # Nice output in kbuild format                    
 40 # Will be supressed by "make -s"                  
 41 info()                                            
 42 {                                                 
 43         printf "  %-7s %s\n" "${1}" "${2}"        
 44 }                                                 
 45                                                   
 46 # Link of vmlinux                                 
 47 # ${1} - output file                              
 48 vmlinux_link()                                    
 49 {                                                 
 50         local output=${1}                         
 51         local objs                                
 52         local libs                                
 53         local ld                                  
 54         local ldflags                             
 55         local ldlibs                              
 56                                                   
 57         info LD ${output}                         
 58                                                   
 59         # skip output file argument               
 60         shift                                     
 61                                                   
 62         if is_enabled CONFIG_LTO_CLANG || is_e    
 63                 # Use vmlinux.o instead of per    
 64                 objs=vmlinux.o                    
 65                 libs=                             
 66         else                                      
 67                 objs=vmlinux.a                    
 68                 libs="${KBUILD_VMLINUX_LIBS}"     
 69         fi                                        
 70                                                   
 71         if is_enabled CONFIG_MODULES; then        
 72                 objs="${objs} .vmlinux.export.    
 73         fi                                        
 74                                                   
 75         objs="${objs} init/version-timestamp.o    
 76                                                   
 77         if [ "${SRCARCH}" = "um" ]; then          
 78                 wl=-Wl,                           
 79                 ld="${CC}"                        
 80                 ldflags="${CFLAGS_vmlinux}"       
 81                 ldlibs="-lutil -lrt -lpthread"    
 82         else                                      
 83                 wl=                               
 84                 ld="${LD}"                        
 85                 ldflags="${KBUILD_LDFLAGS} ${L    
 86                 ldlibs=                           
 87         fi                                        
 88                                                   
 89         ldflags="${ldflags} ${wl}--script=${ob    
 90                                                   
 91         # The kallsyms linking does not need d    
 92         if [ -n "${strip_debug}" ] ; then         
 93                 ldflags="${ldflags} ${wl}--str    
 94         fi                                        
 95                                                   
 96         if is_enabled CONFIG_VMLINUX_MAP; then    
 97                 ldflags="${ldflags} ${wl}-Map=    
 98         fi                                        
 99                                                   
100         ${ld} ${ldflags} -o ${output}             
101                 ${wl}--whole-archive ${objs} $    
102                 ${wl}--start-group ${libs} ${w    
103                 ${kallsymso} ${btf_vmlinux_bin    
104 }                                                 
105                                                   
106 # generate .BTF typeinfo from DWARF debuginfo     
107 # ${1} - vmlinux image                            
108 gen_btf()                                         
109 {                                                 
110         local pahole_ver                          
111         local btf_data=${1}.btf.o                 
112                                                   
113         if ! [ -x "$(command -v ${PAHOLE})" ];    
114                 echo >&2 "BTF: ${1}: pahole ($    
115                 return 1                          
116         fi                                        
117                                                   
118         pahole_ver=$(${PAHOLE} --version | sed    
119         if [ "${pahole_ver}" -lt "116" ]; then    
120                 echo >&2 "BTF: ${1}: pahole ve    
121                 return 1                          
122         fi                                        
123                                                   
124         info BTF "${btf_data}"                    
125         LLVM_OBJCOPY="${OBJCOPY}" ${PAHOLE} -J    
126                                                   
127         # Create ${btf_data} which contains ju    
128         # SHF_ALLOC because .BTF will be part     
129         # deletes all symbols including __star    
130         # be redefined in the linker script. A    
131         # objcopy warnings: "empty loadable se    
132         ${OBJCOPY} --only-section=.BTF --set-s    
133                 --strip-all ${1} "${btf_data}"    
134         # Change e_type to ET_REL so that it c    
135         # GNU ld 2.35+ and lld do not allow an    
136         if is_enabled CONFIG_CPU_BIG_ENDIAN; t    
137                 et_rel='\0\1'                     
138         else                                      
139                 et_rel='\1\0'                     
140         fi                                        
141         printf "${et_rel}" | dd of="${btf_data    
142                                                   
143         btf_vmlinux_bin_o=${btf_data}             
144 }                                                 
145                                                   
146 # Create ${2}.o file with all symbols from the    
147 kallsyms()                                        
148 {                                                 
149         local kallsymopt;                         
150                                                   
151         if is_enabled CONFIG_KALLSYMS_ALL; the    
152                 kallsymopt="${kallsymopt} --al    
153         fi                                        
154                                                   
155         if is_enabled CONFIG_KALLSYMS_ABSOLUTE    
156                 kallsymopt="${kallsymopt} --ab    
157         fi                                        
158                                                   
159         info KSYMS "${2}.S"                       
160         scripts/kallsyms ${kallsymopt} "${1}"     
161                                                   
162         info AS "${2}.o"                          
163         ${CC} ${NOSTDINC_FLAGS} ${LINUXINCLUDE    
164               ${KBUILD_AFLAGS} ${KBUILD_AFLAGS    
165                                                   
166         kallsymso=${2}.o                          
167 }                                                 
168                                                   
169 # Perform kallsyms for the given temporary vml    
170 sysmap_and_kallsyms()                             
171 {                                                 
172         mksysmap "${1}" "${1}.syms"               
173         kallsyms "${1}.syms" "${1}.kallsyms"      
174                                                   
175         kallsyms_sysmap=${1}.syms                 
176 }                                                 
177                                                   
178 # Create map file with all symbols from ${1}      
179 # See mksymap for additional details              
180 mksysmap()                                        
181 {                                                 
182         info NM ${2}                              
183         ${NM} -n "${1}" | sed -f "${srctree}/s    
184 }                                                 
185                                                   
186 sorttable()                                       
187 {                                                 
188         ${objtree}/scripts/sorttable ${1}         
189 }                                                 
190                                                   
191 cleanup()                                         
192 {                                                 
193         rm -f .btf.*                              
194         rm -f System.map                          
195         rm -f vmlinux                             
196         rm -f vmlinux.map                         
197 }                                                 
198                                                   
199 # Use "make V=1" to debug this script             
200 case "${KBUILD_VERBOSE}" in                       
201 *1*)                                              
202         set -x                                    
203         ;;                                        
204 esac                                              
205                                                   
206 if [ "$1" = "clean" ]; then                       
207         cleanup                                   
208         exit 0                                    
209 fi                                                
210                                                   
211 ${MAKE} -f "${srctree}/scripts/Makefile.build"    
212                                                   
213 btf_vmlinux_bin_o=                                
214 kallsymso=                                        
215 strip_debug=                                      
216                                                   
217 if is_enabled CONFIG_KALLSYMS; then               
218         truncate -s0 .tmp_vmlinux.kallsyms0.sy    
219         kallsyms .tmp_vmlinux.kallsyms0.syms .    
220 fi                                                
221                                                   
222 if is_enabled CONFIG_KALLSYMS || is_enabled CO    
223                                                   
224         # The kallsyms linking does not need d    
225         if ! is_enabled CONFIG_DEBUG_INFO_BTF;    
226                 strip_debug=1                     
227         fi                                        
228                                                   
229         vmlinux_link .tmp_vmlinux1                
230 fi                                                
231                                                   
232 if is_enabled CONFIG_DEBUG_INFO_BTF; then         
233         if ! gen_btf .tmp_vmlinux1; then          
234                 echo >&2 "Failed to generate B    
235                 echo >&2 "Try to disable CONFI    
236                 exit 1                            
237         fi                                        
238 fi                                                
239                                                   
240 if is_enabled CONFIG_KALLSYMS; then               
241                                                   
242         # kallsyms support                        
243         # Generate section listing all symbols    
244         # It's a four step process:               
245         # 0)  Generate a dummy __kallsyms with    
246         # 1)  Link .tmp_vmlinux.kallsyms1 so i    
247         #     with a dummy __kallsyms.            
248         #     Running kallsyms on that gives u    
249         #     the right size                      
250         # 2)  Link .tmp_vmlinux.kallsyms2 so i    
251         #     the right size, but due to the a    
252         #     addresses have shifted.             
253         #     From here, we generate a correct    
254         # 3)  That link may have expanded the     
255         #     more linker branch stubs / tramp    
256         #     introduces new names, which furt    
257         #     pass if that is the case. In the    
258         #     in even more stubs, but unlikely    
259         #     KALLSYMS_EXTRA_PASS=1 may also u    
260         #     other bugs.                         
261         # 4)  The correct ${kallsymso} is link    
262         #                                         
263         # a)  Verify that the System.map from     
264         #     ${kallsymso}.                       
265                                                   
266         # The kallsyms linking does not need d    
267         strip_debug=1                             
268                                                   
269         sysmap_and_kallsyms .tmp_vmlinux1         
270         size1=$(${CONFIG_SHELL} "${srctree}/sc    
271                                                   
272         vmlinux_link .tmp_vmlinux2                
273         sysmap_and_kallsyms .tmp_vmlinux2         
274         size2=$(${CONFIG_SHELL} "${srctree}/sc    
275                                                   
276         if [ $size1 -ne $size2 ] || [ -n "${KA    
277                 vmlinux_link .tmp_vmlinux3        
278                 sysmap_and_kallsyms .tmp_vmlin    
279         fi                                        
280 fi                                                
281                                                   
282 strip_debug=                                      
283                                                   
284 vmlinux_link vmlinux                              
285                                                   
286 # fill in BTF IDs                                 
287 if is_enabled CONFIG_DEBUG_INFO_BTF && is_enab    
288         info BTFIDS vmlinux                       
289         ${RESOLVE_BTFIDS} vmlinux                 
290 fi                                                
291                                                   
292 mksysmap vmlinux System.map                       
293                                                   
294 if is_enabled CONFIG_BUILDTIME_TABLE_SORT; the    
295         info SORTTAB vmlinux                      
296         if ! sorttable vmlinux; then              
297                 echo >&2 Failed to sort kernel    
298                 exit 1                            
299         fi                                        
300 fi                                                
301                                                   
302 # step a (see comment above)                      
303 if is_enabled CONFIG_KALLSYMS; then               
304         if ! cmp -s System.map "${kallsyms_sys    
305                 echo >&2 Inconsistent kallsyms    
306                 echo >&2 'Try "make KALLSYMS_E    
307                 exit 1                            
308         fi                                        
309 fi                                                
310                                                   
311 # For fixdep                                      
312 echo "vmlinux: $0" > .vmlinux.d                   
                                                      

~ [ source navigation ] ~ [ diff markup ] ~ [ identifier search ] ~

kernel.org | git.kernel.org | LWN.net | Project Home | SVN repository | Mail admin

Linux® is a registered trademark of Linus Torvalds in the United States and other countries.
TOMOYO® is a registered trademark of NTT DATA CORPORATION.

sflogo.php